# ColumnModel.js

    /**
     * @class Ext.grid.ColumnModel
     * @extends Ext.util.Observable
     * This is the default implementation of a ColumnModel used by the Grid. It defines
     * the columns in the grid.
     * <br>Usage:<br>
     <pre><code>
     var colModel = new Ext.grid.ColumnModel([
    	{header: "Ticker", width: 60, sortable: true, locked: true},
    	{header: "Company Name", width: 150, sortable: true},
    	{header: "Market Cap.", width: 100, sortable: true},
    	{header: "$ Sales", width: 100, sortable: true, renderer: money},
    	{header: "Employees", width: 100, sortable: true, resizable: false}
     ]);
     </code></pre>
     * <p>
     * The config options listed for this class, are options which may appear in each
     * individual column definition.
     * @constructor
     * @param {Object} config An Array of column config objects. See this class's
     * config objects for details.
    */
    Ext.grid.ColumnModel = function(config){
    	Ext.grid.ColumnModel.superclass.constructor.call(this);
        /**
         * The config passed into the constructor
         */
        this.config = config;
        this.lookup = {};

        // if id, create one
        // if the column does not have a dataIndex mapping,
        // map it to the order it is in the config
        for(var i = 0, len = config.length; i < len; i++){
            if(typeof config[i].dataIndex == "undefined"){
                config[i].dataIndex = i;
            }
            if(typeof config[i].renderer == "string"){
                config[i].renderer = Ext.util.Format[config[i].renderer];
            }
            if(typeof config[i].id == "undefined"){
                config[i].id = i;
            }
            this.lookup[config[i].id] = config[i];
        }

        /**
         * The width of columns which have no width specified (defaults to 100)
         * @type Number
         */
        this.defaultWidth = 100;

        /**
         * Default sortable of columns which have no sortable specified (defaults to false)
         * @type Boolean
         */
        this.defaultSortable = false;

        this.addEvents({
            /**
    	     * @event widthchange
    	     * Fires when the width of a column changes
    	     * @param {ColumnModel} this
    	     * @param {Number} columnIndex The column index
    	     * @param {Number} newWidth The new width
    	     */
    	    "widthchange": true,
            /**
    	     * @event headerchange
    	     * Fires when the text of a header changes
    	     * @param {ColumnModel} this
    	     * @param {Number} columnIndex The column index
    	     * @param {Number} newText The new header text
    	     */
    	    "headerchange": true,
            /**
    	     * @event hiddenchange
    	     * Fires when a column is hidden or "unhidden"
    	     * @param {ColumnModel} this
    	     * @param {Number} columnIndex The column index
    	     * @param {Number} hidden true if hidden, false otherwise
    	     */
    	    "hiddenchange": true,
    	    /**
             * @event columnmoved
             * Fires when a column is moved
             * @param {ColumnModel} this
             * @param {Number} oldIndex
             * @param {Number} newIndex
             */
            "columnmoved" : true,
            /**
             * @event columlockchange
             * Fires when a column's locked state is changed
             * @param {ColumnModel} this
             * @param {Number} colIndex
             * @param {Boolean} locked true if locked
             */
            "columnlockchange" : true
        });
        Ext.grid.ColumnModel.superclass.constructor.call(this);
    };
    Ext.extend(Ext.grid.ColumnModel, Ext.util.Observable, {
        /**
         * @cfg header {String} The header text to display in the Grid view.
         */
    // holder
    /***
         * @cfg dataIndex {String} The name of the field in the grid's {@link Ext.data.Store}'s
         * {@link Ext.data.Record} definition from which to draw the column's value. If not
         * specified, the column's index is used as an index into the Record's data Array.
         */
    // holder
    /***
         * @cfg width {Number} (Optional) The initial width in pixels of the column. Using this
         * instead of {@link Ext.grid.Grid#autoSizeColumns} is more efficient.
         */
    // holder
    /***
         * @cfg sortable {Boolean} True if sorting is to be allowed on this column. Defaults to true.
         * Whether local/remote sorting is used is specified in {@link Ext.data.Store#remoteSort}.
         */
    // holder
    /***
         * @cfg locked {Boolean} True to lock the column in place while scrolling the Grid.
         * Defaults to false.
         */
    // holder
    /***
         * @cfg resizable {Boolean} False to disable column resizing. Defaults to true.
         */
    // holder
    /***
         * @cfg renderer {Function} (Optional) A function used to generate HTML markup for a cell
         * given the cell's data value. See {@link #setRenderer}. If not specified, the
         * default renderer uses the raw data value.
         */
    // holder
    /***
         * Returns the id of the column at the specified index
         * @param {Number} index
         * @return {String} the id
         */
        getColumnId : function(index){
            return this.config[index].id;
        },

        getColumnById : function(id){
            return this.lookup[id];
        },

        getIndexById : function(id){
            for(var i = 0, len = this.config.length; i < len; i++){
                if(this.config[i].id == id){
                    return i;
                }
            }
            return -1;
        },

        moveColumn : function(oldIndex, newIndex){
            var c = this.config[oldIndex];
            this.config.splice(oldIndex, 1);
            this.config.splice(newIndex, 0, c);
            this.dataMap = null;
            this.fireEvent("columnmoved", this, oldIndex, newIndex);
        },

        isLocked : function(colIndex){
            return this.config[colIndex].locked === true;
        },

        setLocked : function(colIndex, value, suppressEvent){
            if(this.isLocked(colIndex) == value){
                return;
            }
            this.config[colIndex].locked = value;
            if(!suppressEvent){
                this.fireEvent("columnlockchange", this, colIndex, value);
            }
        },

        getTotalLockedWidth : function(){
            var totalWidth = 0;
            for(var i = 0; i < this.config.length; i++){
                if(this.isLocked(i) && !this.isHidden(i)){
                    this.totalWidth += this.getColumnWidth(i);
                }
            }
            return totalWidth;
        },

        getLockedCount : function(){
            for(var i = 0, len = this.config.length; i < len; i++){
                if(!this.isLocked(i)){
                    return i;
                }
            }
        },

        /**
         * Returns the number of columns.
         * @return {Number}
         */
        getColumnCount : function(visibleOnly){
            if(visibleOnly == true){
                var c = 0;
                for(var i = 0, len = this.config.length; i < len; i++){
                    if(!this.isHidden(i)){
                        c++;
                    }
                }
                return c;
            }
            return this.config.length;
        },

        /**
         * Returns true if the specified column is sortable.
         * @param {Number} col The column index
         * @return {Boolean}
         */
        isSortable : function(col){
            if(typeof this.config[col].sortable == "undefined"){
                return this.defaultSortable;
            }
            return this.config[col].sortable;
        },

        /**
         * Returns the rendering (formatting) function defined for the column.
         * @param {Number} col The column index.
         * @return {Function} The function used to render the cell. See {@link #setRenderer}.
         */
        getRenderer : function(col){
            if(!this.config[col].renderer){
                return Ext.grid.ColumnModel.defaultRenderer;
            }
            return this.config[col].renderer;
        },

        /**
         * Sets the rendering (formatting) function for a column.
         * @param {Number} col The column index
         * @param {Function} fn The function to use to process the cell's raw data
         * to return HTML markup for the grid view. The render function is called with
         * the following parameters:<ul>
         * <li>Data value.</li>
         * <li>Cell metadata. An object in which you may set the following attributes:<ul>
         * <li>css A CSS style string to apply to the table cell.</li>
         * <li>attr An HTML attribute definition string to apply to the data container element <i>within</i> the table cell.</li></ul>
         * <li>The {@link Ext.data.Record} from which the data was extracted.</li>
         * <li>Row index</li>
         * <li>Column index</li>
         * <li>The {@link Ext.data.Store} object from which the Record was extracted</li></ul>
         */
        setRenderer : function(col, fn){
            this.config[col].renderer = fn;
        },

        /**
         * Returns the width for the specified column.
         * @param {Number} col The column index
         * @return {Number}
         */
        getColumnWidth : function(col){
            return this.config[col].width || this.defaultWidth;
        },

        /**
         * Sets the width for a column.
         * @param {Number} col The column index
         * @param {Number} width The new width
         */
        setColumnWidth : function(col, width, suppressEvent){
            this.config[col].width = width;
            this.totalWidth = null;
            if(!suppressEvent){
                 this.fireEvent("widthchange", this, col, width);
            }
        },

        /**
         * Returns the total width of all columns.
         * @param {Boolean} includeHidden True to include hidden column widths
         * @return {Number}
         */
        getTotalWidth : function(includeHidden){
            if(!this.totalWidth){
                this.totalWidth = 0;
                for(var i = 0, len = this.config.length; i < len; i++){
                    if(includeHidden || !this.isHidden(i)){
                        this.totalWidth += this.getColumnWidth(i);
                    }
                }
            }
            return this.totalWidth;
        },

        /**
         * Returns the header for the specified column.
         * @param {Number} col The column index
         * @return {String}
         */
        getColumnHeader : function(col){
            return this.config[col].header;
        },

        /**
         * Sets the header for a column.
         * @param {Number} col The column index
         * @param {String} header The new header
         */
        setColumnHeader : function(col, header){
            this.config[col].header = header;
            this.fireEvent("headerchange", this, col, header);
        },

        /**
         * Returns the tooltip for the specified column.
         * @param {Number} col The column index
         * @return {String}
         */
        getColumnTooltip : function(col){
                return this.config[col].tooltip;
        },
        /**
         * Sets the tooltip for a column.
         * @param {Number} col The column index
         * @param {String} tooltip The new tooltip
         */
        setColumnTooltip : function(col, tooltip){
                this.config[col].tooltip = tooltip;
        },

        /**
         * Returns the dataIndex for the specified column.
         * @param {Number} col The column index
         * @return {Number}
         */
        getDataIndex : function(col){
            return this.config[col].dataIndex;
        },

        /**
         * Sets the dataIndex for a column.
         * @param {Number} col The column index
         * @param {Number} dataIndex The new dataIndex
         */
        setDataIndex : function(col, dataIndex){
            this.config[col].dataIndex = dataIndex;
        },

        findColumnIndex : function(dataIndex){
            var c = this.config;
            for(var i = 0, len = c.length; i < len; i++){
                if(c[i].dataIndex == dataIndex){
                    return i;
                }
            }
            return -1;
        },

        /**
         * Returns true if the cell is editable.
         * @param {Number} colIndex The column index
         * @param {Number} rowIndex The row index
         * @return {Boolean}
         */
        isCellEditable : function(colIndex, rowIndex){
            return (this.config[colIndex].editable || (typeof this.config[colIndex].editable == "undefined" && this.config[colIndex].editor)) ? true : false;
        },

        /**
         * Returns the editor defined for the cell/column.
         * @param {Number} colIndex The column index
         * @param {Number} rowIndex The row index
         * @return {Object}
         */
        getCellEditor : function(colIndex, rowIndex){
            return this.config[colIndex].editor;
        },

        /**
         * Sets if a column is editable.
         * @param {Number} col The column index
         * @param {Boolean} editable True if the column is editable
         */
        setEditable : function(col, editable){
            this.config[col].editable = editable;
        },

        /**
         * Returns true if the column is hidden.
         * @param {Number} colIndex The column index
         * @return {Boolean}
         */
        isHidden : function(colIndex){
            return this.config[colIndex].hidden;
        },

        /**
         * Returns true if the column width cannot be changed
         */
        isFixed : function(colIndex){
            return this.config[colIndex].fixed;
        },

        /**
         * Returns true if the column cannot be resized
         * @return {Boolean}
         */
        isResizable : function(colIndex){
            return this.config[colIndex].resizable !== false;
        },
        /**
         * Sets if a column is hidden.
         * @param {Number} colIndex The column index
         * @param {Boolean} hidden True if the column is hidden
         */
        setHidden : function(colIndex, hidden){
            this.config[colIndex].hidden = hidden;
            this.totalWidth = null;
            this.fireEvent("hiddenchange", this, colIndex, hidden);
        },

        /**
         * Sets the editor for a column.
         * @param {Number} col The column index
         * @param {Object} editor The editor object
         */
        setEditor : function(col, editor){
            this.config[col].editor = editor;
        }
    });

    Ext.grid.ColumnModel.defaultRenderer = function(value){
    	if(typeof value == "string" && value.length < 1){
    	    return "&#160;";
    	}
    	return value;
    };

    // Alias for backwards compatibility
    Ext.grid.DefaultColumnModel = Ext.grid.ColumnModel;

Ext - Copyright © 2006-2007 Ext JS, LLC
All rights reserved.